"""
A cherub enemy.
"""

import pygame, math
from pygame.locals import *
from my_sprite import my_sprite

class cherub(my_sprite):
    def __init__(self, game, loc, initial_facing, initial_state):
        my_sprite.__init__(self, game, loc, "Cherub", initial_facing, initial_state, False, True)
        
    def update_state(self):
        # Am I hit?
#        if self.cr_flags["Vulnerable"] and self.state != "Hurt":
#            self.set_state("Hurt")
#            self.vel[0] = 0
        
        # Constantly float around
        if self.what_under:
            if self.state == "Float":
                if self.facing == 0:
                    self.vel[0] = 0.5
                else:
                    self.vel[0] = -0.5
                        
                # Have it turn around at the edges of whatever surface he is walking on
                if self.check_edge():
                    self.facing = (self.facing + 1) % 2
                    self.vel[0] = -self.vel[0]
        else:
            self.vel[0] = 0

        # Back to normal states
        if self.anim_runs > 0:
            if self.state == "Hurt":
                self.set_state("Float")

    def check_edge(self):
        if self.facing == 0:
            t_x = int(self.r.x + self.r.w) // self.game.t.tile_size
        else:
            t_x = int(self.r.x) // self.game.t.tile_size
        t_y = int(self.r.y + self.r.h) // self.game.t.tile_size

        i = self.game.t.map[t_y][t_x]
        t = self.game.t.tileset[i]

        return (i == -1 or t.obstruction == "None")
